searchNodes=[{"doc":"This module provides high-level Fluvio interface for cluster functionalities.","ref":"Fluvio.html","title":"Fluvio","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.html#child_spec/1","title":"Fluvio.child_spec/1","type":"function"},{"doc":"Gets the platform version of the connected cluster.","ref":"Fluvio.html#platform_version/1","title":"Fluvio.platform_version/1","type":"function"},{"doc":"Starts a GenServer process linked to the current process connected to Fluvio cluster.","ref":"Fluvio.html#start_link/2","title":"Fluvio.start_link/2","type":"function"},{"doc":"Fluvio Admin cluster functionalities. This module is backed by a GenServer.","ref":"Fluvio.Admin.html","title":"Fluvio.Admin","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.Admin.html#child_spec/1","title":"Fluvio.Admin.child_spec/1","type":"function"},{"doc":"Creates a topic.","ref":"Fluvio.Admin.html#create_topic/3","title":"Fluvio.Admin.create_topic/3","type":"function"},{"doc":"Deletes a topic.","ref":"Fluvio.Admin.html#delete_topic/2","title":"Fluvio.Admin.delete_topic/2","type":"function"},{"doc":"Starts a GenServer process linked to the current process connected to Fluvio cluster.","ref":"Fluvio.Admin.html#start_link/2","title":"Fluvio.Admin.start_link/2","type":"function"},{"doc":"PartitionConsumer functionalities. This module is backed by a GenServer.","ref":"Fluvio.Consumer.html","title":"Fluvio.Consumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.Consumer.html#child_spec/1","title":"Fluvio.Consumer.child_spec/1","type":"function"},{"doc":"Starts a Fluvio PartitionConsumer GenServer process linked to the current process.","ref":"Fluvio.Consumer.html#start_link/3","title":"Fluvio.Consumer.start_link/3","type":"function"},{"doc":"Invokes the given func/1 for each result in the stream continuously.","ref":"Fluvio.Consumer.html#stream_each/3","title":"Fluvio.Consumer.stream_each/3","type":"function"},{"doc":"Gets next record of the stream. If you want to traverse continuously the stream, you can call stream_each/3 , or alternatively recursively call this function.","ref":"Fluvio.Consumer.html#stream_next/2","title":"Fluvio.Consumer.stream_next/2","type":"function"},{"doc":"Unfolds the infinite stream lazily. timeout_iter_ms is a low-level iteration timeout in ms to avoid blocking the DirtyIO Rust NIF for too long.","ref":"Fluvio.Consumer.html#stream_unfold/2","title":"Fluvio.Consumer.stream_unfold/2","type":"function"},{"doc":"TopicProducer functionalities. This module is backed by a GenServer.","ref":"Fluvio.Producer.html","title":"Fluvio.Producer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fluvio.Producer.html#child_spec/1","title":"Fluvio.Producer.child_spec/1","type":"function"},{"doc":"Flushes all the queued records in the producer batches.","ref":"Fluvio.Producer.html#flush/1","title":"Fluvio.Producer.flush/1","type":"function"},{"doc":"Sends a list of string values or tuple key values to this producer's topic. flush/1 should be called to flush the records in the producer batches.","ref":"Fluvio.Producer.html#send/2","title":"Fluvio.Producer.send/2","type":"function"},{"doc":"Sends a key value record to this producer's topic. flush/1 should be be called to flush the records in the producer batches.","ref":"Fluvio.Producer.html#send/3","title":"Fluvio.Producer.send/3","type":"function"},{"doc":"Starts a Fluvio TopicProducer GenServer process linked to the current process. Config example: %{topic: &quot;some_topic&quot;, options: %{}}","ref":"Fluvio.Producer.html#start_link/3","title":"Fluvio.Producer.start_link/3","type":"function"},{"doc":"fluvio-ex 💧Elixir client for Fluvio streaming platform Docs","ref":"readme.html","title":"README","type":"extras"},{"doc":"You can add fluvio to your list of dependencies in mix.exs : def deps do [ { :fluvio , &quot;~&gt; 0.2.0&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"The following Fluvio Rust abstractions are supported on Elixir: Rust Elixir fluvio::PartitionConsumer Fluvio.Consumer fluvio::TopicProducer Fluvio.Producer fluvio::FluvioAdmin Fluvio.Admin Each Elixir abstraction tend to provide equivalent functionalities that fluvio crate exposes , although more Elixir-oriented to be well integrated with Elixir ecosystem and OTP. fluvio::FluvioAdmin is minimally supported since provisioning cluster resources is typically done upfront and not at the application level, but for experimentation it's useful to have Fluvio.Admin .","ref":"readme.html#features","title":"README - Features","type":"extras"},{"doc":"Consumer This snippet illustrates a Consumer connected to a &quot;lobby&quot; topic and using an optional SmarModule filter. Initially, this consumer calls Consumer.stream_unfold/2 to lazily take 4 reords and chunk every 2 records, printing them. After that, keeps executing Consumer.stream_each/2 consuming the stream. Consumer.stream_each is a higher-level function that recursively calls Consumer.stream_next/2 . alias Fluvio.Consumer { :ok , pid } = Consumer . start_link ( %{ topic : &quot;lobby&quot; , offset : [ from_beginning : 0 ] , smartmodule_path : &quot;./examples/wasm/map_reverse.wasm&quot; } ) Consumer . stream_unfold ( pid ) |&gt; Stream . take ( 4 ) |&gt; Stream . chunk_every ( 2 ) |&gt; Enum . to_list ( ) |&gt; IO . inspect ( ) Consumer . stream_each ( pid , fn result -&gt; case result do { :ok , record } -&gt; IO . inspect ( record ) { :error , msg } -&gt; IO . inspect ( &quot;Error: \#{ msg } &quot; ) end end ) Producer This snippet illustrates a Producer connected to a &quot;lobby&quot; topic. Initially, a string &quot;hello&quot; is sent and flushed, after that, more three strigs &quot;are&quot; , &quot;you&quot; , &quot;there?&quot; are sent and asserted. Finally, integers from 1 to 20 mapped as strings are sent asynchronously in chunk of 10 performing a flush between each iteration. If you're going to send and await records asynchronusly, make sure that it's suitable and benefitial to your application: alias Fluvio.Producer { :ok , pid } = Producer . start_link ( %{ topic : &quot;lobby&quot; } ) { :ok , _ } = Producer . send ( pid , &quot;hello&quot; ) { :ok , _ } = Producer . flush ( pid ) Producer . send ( pid , [ &quot;are&quot; , &quot;you&quot; , &quot;there?&quot; ] ) |&gt; Enum . each ( &amp; ( { :ok , _ } = &amp;1 ) ) { :ok , _ } = Producer . flush ( pid ) [ ] = 1 .. 20 |&gt; Stream . chunk_every ( 10 ) |&gt; Stream . flat_map ( fn chunk -&gt; [ chunk |&gt; Enum . map ( fn value -&gt; Task . async ( fn -&gt; { Producer . send ( pid , to_string ( value ) ) , value } end ) end ) |&gt; Task . await_many ( ) |&gt; Enum . filter ( &amp; match? ( { { :error , _msg } , _value } , &amp;1 ) ) , [ { Producer . flush ( pid ) , :flush } ] |&gt; Enum . filter ( &amp; match? ( { { :error , _msg } , _value } , &amp;1 ) ) ] end ) |&gt; Stream . concat ( ) |&gt; Enum . to_list ( )","ref":"readme.html#examples","title":"README - Examples","type":"extras"}]